



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SpringBoot的Web开发</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SpringBoot的Web开发</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-16 10:27:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、创建Web项目</p>
<p>创建的时候勾选对应web选项即可，会自动引入相应的starter，pom如下：</p>
<div>
<pre class="prettyprint linenums">&lt;dependency&gt;<br />
    &lt;groupId&gt;org.springframework.boot&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-boot-starter-web&lt;/artifactId&gt;<br />
&lt;/dependency&gt;</pre>
</div>
<p>里面的具体依赖不一一展开了。</p>
<p>二、SpringBoot的Web自动配置</p>
<p>经过前面的研究，知道主要是springboot为我们引入了org.springframework.boot.autoconfigure.web包的</p>
<p>1.自动配置类：xxxxAutoConfiguration帮我们给容器中自动配置组件；</p>
<p>2.配置文件封装类：xxxxProperties:配置类来封装配置文件的内容；</p>
<p>eg：DispatcherServletAutoConfiguration、WebMvcAutoConfiguration和WebMvcProperties、ResourceProperties</p>
<p>具体自动配置帮我们做了什么可以看xxxxAutoConfiguration，我们配置文件能配置什么属性可以看xxxxProperties。</p>
<p>三、springboot web的静态资源映射规则</p>
<p>1.ResourceProperties</p>
<div>
<pre class="prettyprint linenums">@ConfigurationProperties(<strong>prefix = "spring.resources"</strong>, ignoreUnknownFields = false)<br />
public class ResourceProperties {

    private static final String[] CLASSPATH_RESOURCE_LOCATIONS = {<br />
            "classpath:/META-INF/resources/", "classpath:/resources/",<br />
            "classpath:/static/", "classpath:/public/" };

    /**<br />
     * Locations of static resources. Defaults to classpath:[/META-INF/resources/,<br />
     * /resources/, /static/, /public/].<br />
     */<br />
    private String[] staticLocations = CLASSPATH_RESOURCE_LOCATIONS;

    /**<br />
     * Whether to enable default resource handling.<br />
     */<br />
    private boolean addMappings = true;

    private final Chain chain = new Chain();

    private final Cache cache = new Cache();

    public String[] getStaticLocations() {<br />
        return this.staticLocations;<br />
    }

    public void setStaticLocations(String[] staticLocations) {<br />
        this.staticLocations = appendSlashIfNecessary(staticLocations);<br />
    }

    private String[] appendSlashIfNecessary(String[] staticLocations) {<br />
        String[] normalized = new String[staticLocations.length];<br />
        for (int i = 0; i &lt; staticLocations.length; i++) {<br />
            String location = staticLocations[i];<br />
            normalized[i] = location.endsWith("/") ? location : location + "/";<br />
        }<br />
        return normalized;<br />
    }</pre>
</div>
<p>可以看到springboot自动配置默认回到</p>
<pre class="prettyprint linenums">"classpath:/META-INF/resources/",<br />"classpath:/resources/",<br />
"classpath:/static/", <br />"classpath:/public/"<br />目录下寻找静态资源。<br />2.WebMvcAuotConfiguration</pre>
<div>
<pre class="prettyprint linenums">@Override<br />
        public void addResourceHandlers(ResourceHandlerRegistry registry) {<br />
            if (!this.resourceProperties.isAddMappings()) {<br />
                logger.debug("Default resource handling disabled");<br />
                return;<br />
            }<br />
            Integer cachePeriod = this.resourceProperties.getCachePeriod();<br />
            if (!registry.hasMappingForPattern("<strong>/webjars/**</strong>")) {<br />
                customizeResourceHandlerRegistration(<br />
                        registry.addResourceHandler("/webjars/**")<br />
                                .addResourceLocations(<br />
                                        "classpath:/META-INF/resources/webjars/")<br />
                        .setCachePeriod(cachePeriod));<br />
            }<br />
            String staticPathPattern = this.mvcProperties.getStaticPathPattern();<br />
              //静态资源文件夹映射<br />
            if (!registry.hasMappingForPattern(staticPathPattern)) {<br />
                customizeResourceHandlerRegistration(<br />
                        registry.addResourceHandler(staticPathPattern)<br />
                                .addResourceLocations(<br />
                                        this.resourceProperties.getStaticLocations())<br />
                        .setCachePeriod(cachePeriod));<br />
            }<br />
        }

        //配置欢迎页映射<br />
        @Bean<br />
        public WelcomePageHandlerMapping welcomePageHandlerMapping(<br />
                ResourceProperties resourceProperties) {<br />
            return new WelcomePageHandlerMapping(resourceProperties.getWelcomePage(),<br />
                    this.mvcProperties.getStaticPathPattern());<br />
        }</pre>
<p>　　　　　　private Optional&lt;Resource&gt; getWelcomePage() {<br />			　　　　　　　　String[] locations = getResourceLocations(<br />					　　　　　　　　this.resourceProperties.getStaticLocations());<br />			　　　　　　　　return Arrays.stream(locations).map(this::getIndexHtml)<br />					　　　　　　　　.filter(this::isReadable).findFirst();<br />		　　　　　　}</p>
<pre class="prettyprint linenums"></pre>
<p>　　　　　　private Resource getIndexHtml(String location) {<br />			　　　　　　　　return this.resourceLoader.getResource(location + "<strong>index.html</strong>");<br />		　　　　　　}</p>
<pre class="prettyprint linenums">//配置喜欢的图标<br />
        @Configuration<br />
        @ConditionalOnProperty(value = "spring.mvc.favicon.enabled", matchIfMissing = true)<br />
        public static class FaviconConfiguration {

            private final ResourceProperties resourceProperties;

            public FaviconConfiguration(ResourceProperties resourceProperties) {<br />
                this.resourceProperties = resourceProperties;<br />
            }

            @Bean<br />
            public SimpleUrlHandlerMapping faviconHandlerMapping() {<br />
                SimpleUrlHandlerMapping mapping = new SimpleUrlHandlerMapping();<br />
                mapping.setOrder(Ordered.HIGHEST_PRECEDENCE + 1);<br />
                  //所有  **/favicon.ico<br />
                mapping.setUrlMap(Collections.singletonMap("<strong>**/favicon.ico</strong>",<br />
                        faviconRequestHandler()));<br />
                return mapping;<br />
            }

            @Bean<br />
            public ResourceHttpRequestHandler faviconRequestHandler() {<br />
                ResourceHttpRequestHandler requestHandler = new ResourceHttpRequestHandler();<br />
                requestHandler<br />
                        .setLocations(this.resourceProperties.getFaviconLocations());<br />
                return requestHandler;<br />
            }

        }</pre>
</div>
<p>1.webjars：允许我们以jar的方式引入静态资源（<a href="http://www.webjars.org/" rel="external nofollow noreferrer">http://www.webjars.org/</a>），如jQuery</p>
<div>
<pre class="prettyprint linenums">&lt;!--引入jquery-webjar--&gt;在访问的时候只需要写webjars下面资源的名称即可<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.webjars&lt;/groupId&gt;<br />
            &lt;artifactId&gt;jquery&lt;/artifactId&gt;<br />
            &lt;version&gt;3.3.1&lt;/version&gt;<br />
        &lt;/dependency&gt;</pre>
</div>
<p>访问路径：localhost:8080<strong>/webjars</strong>/jquery/3.3.1/jquery.js</p>
<p>2.欢迎页，默认静态资源根目录/ndex.html</p>
<p>3.页面标签页图标，默认静态资源根目录/favicon.ico</p>
<p>四、Web自定义设置</p>
<p>以上这些都是了解到的默认配置，但有的时候不满足实际需求需要我们自定义配置，下节边自定义边研究原理。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93jd7r8.html">iPad版微信终于来临了 微信5&period;4版搜索更智能 转账就是发消息</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnwzejq.html">JSP计算器</a>
		</li>
						<li><a href="https://www.batexi.com/a/495vel6q.html">perl 二维数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m1ero8.html">R语言简单聚类分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qym5djq.html">Android nDrawer</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q76jok8.html">喝咖啡写脚本&comma;顺便再加一点点CSS语法糖 1&period;选择环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rjn578.html">HDU 1754 I Hate It（线段树单点更新区间最值查询）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm0vzz9.html">Qt 静态函数QMetaObject&colon;&colon;connectSlotsByName&lpar;QObject &ast; object&rpar;按命名规则自动connect，不需要手动connect</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1zmjk8.html">qt环境问题导致的编译错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvm2kxq.html">【Java】Java XML 技术专题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wz7nxq.html">django初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojv11pq.html">Linux的iptables常用配置范例（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1nwd1q.html">XML （二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mj3pq.html">Kindeditor富文本实现textarea文本域的上传及单独button 按钮绑定&lpar;用来实现单文件上传&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyr63q.html">Windows中的备份和还原</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wndz0q.html">在Winform开发框架中实现对数据库的加密支持（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w3mwzq.html">Spring Boot之执行器端点&lpar;Actuator Endpoint&rpar;实现剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwm6x09.html">Vue过渡动画&mdash;Vue学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd0rze9.html">Linux常用基本命令&lpar;cut&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlk1dl9.html">ElasticSearch 2 &lpar;16&rpar; - 深入搜索系列之近似度匹配</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96pev1y8.html">Form 表单相关小技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj27k38.html">SpringMVC整合Mybatis的流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j47l38.html">Luogu P1082 同余方程&lpar;NOIP 2012&rpar; 题解报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gewnv08.html">C&num;中 将图片保存到Sql server 中</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6ej09.html">解决本地SqlServer无法连接远程服务器数据库，错误10060</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geo1y08.html">【Android入门】一个App学会安卓开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk7w308.html">开源litemall学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgvzod8.html">C&num;创建 WebApi 项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp7pjxq.html">2018-2019-2 20165231 王杨鸿永 Exp6 信息搜集与漏洞扫描</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pvpzn8.html">查看oracle表空间</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
